<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "product_element_category".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProductElementCategory".
 *
 * Columns in table "product_element_category" available as properties of the model,
 * followed by relations of table "product_element_category" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 *
 * @property ProductElement[] $productElements
 */
abstract class BaseProductElementCategory extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'product_element_category';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProductElementCategory|ProductElementCategories', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('id, name', 'required'),
            array('id', 'numerical', 'integerOnly'=>true),
            array('name', 'length', 'max'=>45),
            array('id, name', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'productElements' => array(self::HAS_MANY, 'ProductElement', 'product_element_category_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'productElements' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
